<?php

namespace Drupal\formazing\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for Formazing entity edit forms.
 *
 * @ingroup formazing
 */
class FormazingEntityForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(
    array $form, FormStateInterface $form_state, $formazing = NULL
  ) {
    /* @var $entity \Drupal\formazing\Entity\FormazingEntity */
    $form = parent::buildForm($form, $form_state);
    $form['recipients']['#states'] = [
      'visible' => [
        ':input[name="has_recipients[value]"]' => ['checked' => TRUE],
      ],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    /** @var \Drupal\formazing\Entity\FormazingEntity $entity */
    $entity = &$this->entity;
    $entity->save();

    $status = parent::save($form, $form_state);

    switch ($status) {
      case SAVED_NEW:
        \Drupal::messenger()
          ->addStatus($this->t('Created the %label Formazing entity.', [
            '%label' => $entity->label(),
          ]));
        break;
      default:
        \Drupal::messenger()
          ->addStatus($this->t('Saved the %label Formazing entity.', [
            '%label' => $entity->label(),
          ]));
    }

    $form_state->setRedirect('entity.formazing_entity.canonical', ['formazing_entity' => $entity->id()]);
  }

}
